<?php
/*
Plugin Name: Text Spinner
Plugin URI: http://wpgurus.net/
Description: Allows you to use spintax in your posts, pages and theme files.
Version: 0.1
Author: Hassan Akhtar
Author URI: http://wpgurus.net/
License: GPL2
*/

/**********************************************
*
* Spintax functions
*
***********************************************/

function wpts_spin($text)
{
    return preg_replace_callback(
        '/\{(((?>[^\{\}]+)|(?R))*)\}/x',
        'wpts_replace',
        $text
    );
}

function wpts_replace($text)
{
    $text = wpts_spin($text[1]);
    $parts = explode('|', $text);
    return $parts[array_rand($parts)];
}

/**********************************************
*
* Shorcode setup
*
***********************************************/

function wpts_render_shortcode( $atts, $content = null ) {
	return wpts_spin($content);
}
add_shortcode( 'wpts_spin', 'wpts_render_shortcode' );